Tin An Ninh Mạng

Lỗi Squirrel Engine cho phép tin tặc tấn công trò chơi và dịch vụ đám mây

Các nhà nghiên cứu đã tiết lộ một lỗ hổng bất thường trong ngôn ngữ lập trình Squirrel có thể bị những kẻ tấn công lạm dụng để vượt qua giới hạn của sandbox và thực thi mã tùy ý trong SquirrelVM, từ đó truy cập hoàn toàn vào nền tảng máy chủ cơ bản.


{

}

squirrel-game-programming-language.jpg

Với mã định danh là CVE-2021-41556, sự cố xảy ra khi thư viện trò chơi Squirrel Engine được sử dụng để thực thi mã không đáng tin cậy và ảnh hưởng đến các phiên bản phát hành ổn định 3.x và 2.x của Squirrel. Lỗ hổng an ninh đã được tiết lộ vào ngày 10 tháng 8 năm 2021.

Squirrel là một ngôn ngữ lập trình hướng đối tượng, mã nguồn mở được sử dụng để viết kịch bản trò chơi điện tử cũng như trong các thiết bị IoT và các nền tảng xử lý giao dịch phân tán như Enduro/X.

Squirrel Engine là công cụ trò chơi đa luồng cho mục đích giáo dục, được tạo ra để làm ví dụ cho thiết kế công cụ trò chơi đa lõi hiệu quả. Nó được xây dựng để đạt được hiệu suất tối đa trên các thiết bị máy tính cao cấp.

Đặc trưng:

  • Hiệu suất cao đa luồng, vận hành hệ thống công việc chi phí thấp
  • Nhẹ, dễ sử dụng
  • Hệ thống thành phần thực thể hoạt động đầy đủ
  • Kết xuất dựa trên vật lý
  • Hệ thống vật liệu PBR
  • MSAA , FXAA
  • Point, Directional and Spotlight Sources
  • Công cụ âm thanh hỗ trợ DirectSound
  • Mô-đun AI dựa trên Behavioral Tree and Blackboard

Các nhà nghiên cứu cho biết: “Trong thực tế, kẻ tấn công có thể nhúng một tập lệnh Squirrel độc hại vào bản đồ cộng đồng và phân phối nó thông qua Steam Workshop đáng tin cậy. Khi chủ sở hữu máy chủ tải xuống và cài đặt bản đồ độc hại này, tập lệnh Squirrel sẽ được thực thi, vượt qua máy ảo và chiếm quyền kiểm soát máy chủ”.

Lỗ hổng an ninh này được xác định liên quan đến “quyền truy cập ngoài giới hạn thông qua chỉ mục” khi xác định các lớp Squirrel có thể bị khai thác để chiếm đoạt luồng điều khiển của một chương trình và giành toàn quyền kiểm soát Squirrel VM.

Mặc dù lỗ hổng này đã được giải quyết từ ngày 16 tháng 9, nhưng đáng chú ý là các bản vá chưa được bao gồm trong bản phát hành ổn định mới. Những người bảo trì phụ thuộc vào Squirrel trong các dự án của họ được khuyến nghị áp dụng các bản sửa lỗi mới nhất bằng cách xây dựng lại nó từ mã nguồn để không bị ảnh hưởng bởi bất kỳ cuộc tấn công nào.

Nguồn: The Hacker News

Đăng ký liền tay Nhận Ngay Bài Mới

Subscribe ngay

Cám ơn bạn đã đăng ký !

Lỗi đăng ký !

Add Comment

Click here to post a comment

Đăng ký liền tay
Nhận Ngay Bài Mới

Subscribe ngay

Cám ơn bạn đã đăng ký !

Lỗi đăng ký !